# HG changeset patch
# Node ID 20b54e135fde
# Parent  2794bb8587d3
diff --git a/ChangeLog.API b/ChangeLog.API
--- a/ChangeLog.API
+++ b/ChangeLog.API
@@ -249,6 +249,14 @@
 		* account-setting-info, account-set-info signals
 		* account-status-changing signal.
 		* blocked-img-msg signal.
+		* buddy-caps-changed signal.
+		* buddy-got-login-time signal.
+		* buddy-icon-changed signal.
+		* buddy-idle-changed signal.
+		* buddy-privacy-changed signal.
+		* buddy-removed-from-group signal.
+		* buddy-signed-off signal.
+		* buddy-signed-on signal.
 		* buddy-status-changed signal.
 		* buddy-typed signal.
 		* buddy-typing signal.
@@ -287,6 +295,8 @@
 		* PURPLE_ACCOUNT_RESPONSE_IGNORE
 		* PURPLE_ACCOUNT_RESPONSE_PASS
 		* PurpleAccountUiOps
+		* purple_account_add_buddy
+		* purple_account_add_buddies
 		* purple_account_add_buddies_with_invite
 		* purple_account_add_buddy_with_invite
 		* purple_account_destroy_log
@@ -322,6 +332,8 @@
 		* purple_account_privacy_get_permitted
 		* purple_account_privacy_permit_add
 		* purple_account_privacy_permit_remove
+		* purple_account_remove_buddy
+		* purple_account_remove_buddies
 		* purple_account_remove_setting
 		* purple_account_request_add. Use purple_add_contact_request_new
 		  instead.
@@ -344,6 +356,7 @@
 		* purple_account_set_ui_bool
 		* purple_account_set_username. Use purple_contact_info_set_username
 		  instead.
+		* purple_account_supports_offline_message
 		* account-status-changed signal
 		* purple_accounts_add
 		* purple_accounts_find
@@ -367,6 +380,8 @@
 		* purple_attention_type_get_unlocalized_name
 		* purple_base16_*
 		* purple_base64_*. Use g_base64_* instead
+		* purple_blist_add_account
+		* purple_blist_add_buddy
 		* purple_blist_add_chat
 		* purple_blist_find_chat
 		* purple_blist_get_ui_data
@@ -374,6 +389,8 @@
 		* purple_blist_new
 		* purple_blist_node_get_ui_data
 		* purple_blist_node_set_ui_data
+		* purple_blist_remove_account
+		* purple_blist_remove_buddy
 		* purple_blist_remove_chat
 		* purple_blist_request_add_chat
 		* purple_blist_set_ui_data
diff --git a/libpurple/accounts.c b/libpurple/accounts.c
--- a/libpurple/accounts.c
+++ b/libpurple/accounts.c
@@ -33,6 +33,8 @@
 #include "purplecredentialmanager.h"
 #include "purpleenums.h"
 #include "purpleprivate.h"
+#include "signals.h"
+#include "util.h"
 
 static guint    save_timer = 0;
 static gboolean accounts_loaded = FALSE;
@@ -395,24 +397,6 @@
 		g_free(data);
 	}
 
-	/* Read an old buddyicon */
-	child = purple_xmlnode_get_child(node, "buddyicon");
-	if ((child != NULL) && ((data = purple_xmlnode_get_data(child)) != NULL))
-	{
-		const char *dirname = purple_buddy_icons_get_cache_dir();
-		char *filename = g_build_filename(dirname, data, NULL);
-		gchar *contents;
-		gsize len;
-
-		if (g_file_get_contents(filename, &contents, &len, NULL))
-		{
-			purple_buddy_icons_set_account_icon(ret, (guchar *)contents, len);
-		}
-
-		g_free(filename);
-		g_free(data);
-	}
-
 	/* Read settings (both core and UI) */
 	for (child = purple_xmlnode_get_child(node, "settings"); child != NULL;
 			child = purple_xmlnode_get_next_twin(child))
@@ -463,8 +447,6 @@
 	}
 
 	purple_xmlnode_free(node);
-
-	_purple_buddy_icons_account_loaded_cb();
 }
 
 static void
@@ -493,7 +475,6 @@
 purple_accounts_delete(PurpleAccount *account)
 {
 	PurpleAccountManager *manager = NULL;
-	PurpleBlistNode *gnode = NULL, *cnode = NULL, *bnode = NULL;
 	PurpleConversationManager *conv_manager = NULL;
 	PurpleCredentialManager *cred_manager = NULL;
 	GList *iter = NULL;
@@ -514,37 +495,6 @@
 	manager = purple_account_manager_get_default();
 	purple_account_manager_remove(manager, account);
 
-	/* Remove this account's buddies */
-	for(gnode = purple_blist_get_default_root(); gnode != NULL;
-	    gnode = purple_blist_node_get_sibling_next(gnode))
-	{
-		if(!PURPLE_IS_GROUP(gnode)) {
-			continue;
-		}
-
-		cnode = purple_blist_node_get_first_child(gnode);
-		while(cnode) {
-			PurpleBlistNode *cnode_next = purple_blist_node_get_sibling_next(cnode);
-
-			if(PURPLE_IS_META_CONTACT(cnode)) {
-				bnode = purple_blist_node_get_first_child(cnode);
-				while(bnode) {
-					PurpleBlistNode *bnode_next = purple_blist_node_get_sibling_next(bnode);
-
-					if (PURPLE_IS_BUDDY(bnode)) {
-						PurpleBuddy *b = (PurpleBuddy *)bnode;
-
-						if(purple_buddy_get_account(b) == account) {
-							purple_blist_remove_buddy(b);
-						}
-					}
-					bnode = bnode_next;
-				}
-			}
-			cnode = cnode_next;
-		}
-	}
-
 	/* Remove any open conversation for this account */
 	conv_manager = purple_conversation_manager_get_default();
 	iter = purple_conversation_manager_get_all(conv_manager);
@@ -558,9 +508,6 @@
 		iter = g_list_delete_link(iter, iter);
 	}
 
-	/* This will cause the deletion of an old buddy icon. */
-	purple_buddy_icons_set_account_icon(account, NULL, 0);
-
 	/* This is async because we do not want the
 	 * account being overwritten before we are done.
 	 */
diff --git a/libpurple/blistnode.c b/libpurple/blistnode.c
--- a/libpurple/blistnode.c
+++ b/libpurple/blistnode.c
@@ -21,7 +21,10 @@
  */
 
 #include "blistnode.h"
-#include "buddy.h"
+
+#include "buddylist.h"
+#include "signals.h"
+#include "util.h"
 
 typedef struct _PurpleBlistNodePrivate  PurpleBlistNodePrivate;
 
@@ -48,33 +51,11 @@
 /* Buddy list node API                                                    */
 /**************************************************************************/
 
-static PurpleBlistNode *get_next_node(PurpleBlistNode *node, gboolean godeep)
+PurpleBlistNode *
+purple_blist_node_next(G_GNUC_UNUSED PurpleBlistNode *node,
+                       G_GNUC_UNUSED gboolean offline)
 {
-	if (node == NULL)
-		return NULL;
-
-	if (godeep && node->child)
-		return node->child;
-
-	if (node->next)
-		return node->next;
-
-	return get_next_node(node->parent, FALSE);
-}
-
-PurpleBlistNode *purple_blist_node_next(PurpleBlistNode *node, gboolean offline)
-{
-	PurpleBlistNode *ret = node;
-
-	if (offline)
-		return get_next_node(ret, TRUE);
-	do
-	{
-		ret = get_next_node(ret, TRUE);
-	} while (ret && PURPLE_IS_BUDDY(ret) &&
-			!purple_account_is_connected(purple_buddy_get_account((PurpleBuddy *)ret)));
-
-	return ret;
+	return NULL;
 }
 
 PurpleBlistNode *purple_blist_node_get_parent(PurpleBlistNode *node)
diff --git a/libpurple/buddylist.h b/libpurple/buddylist.h
--- a/libpurple/buddylist.h
+++ b/libpurple/buddylist.h
@@ -29,7 +29,6 @@
 
 /* I can't believe I let ChipX86 inspire me to write good code. -Sean */
 
-#include "buddy.h"
 #include "purpleaccount.h"
 #include "purpleversion.h"
 
@@ -251,20 +250,6 @@
 void purple_blist_set_visible(gboolean show);
 
 /**
- * purple_blist_update_buddies_cache:
- * @buddy:    The buddy whose name will be changed.
- * @new_name: The new name of the buddy.
- *
- * Updates the buddies hash table when a buddy has been renamed. This only
- * updates the cache, the caller is responsible for the actual renaming of
- * the buddy after updating the cache.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-void purple_blist_update_buddies_cache(PurpleBuddy *buddy, const char *new_name);
-
-/**
  * purple_blist_update_groups_cache:
  * @group:    The group whose name will be changed.
  * @new_name: The new name of the group.
@@ -279,25 +264,6 @@
 void purple_blist_update_groups_cache(PurpleGroup *group, const char *new_name);
 
 /**
- * purple_blist_add_buddy:
- * @buddy:   The new buddy who gets added
- * @contact: The optional contact to place the buddy in.
- * @group:   The group to add the new buddy to.
- * @node:    The insertion point.  Pass in NULL to add the node as
- *                the first child in the given group.
- *
- * Adds a new buddy to the buddy list.
- *
- * The buddy will be inserted right after node or prepended to the
- * group if node is NULL.  If both are NULL, the buddy will be added to
- * the default group.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_blist_add_buddy(PurpleBuddy *buddy, PurpleMetaContact *contact, PurpleGroup *group, PurpleBlistNode *node);
-
-/**
  * purple_blist_add_group:
  * @group:  The group
  * @node:   The insertion point
@@ -329,20 +295,6 @@
 void purple_blist_add_contact(PurpleMetaContact *contact, PurpleGroup *group, PurpleBlistNode *node);
 
 /**
- * purple_blist_remove_buddy:
- * @buddy:   The buddy to be removed
- *
- * Removes a buddy from the buddy list and frees the memory allocated to it.
- * This doesn't actually try to remove the buddy from the server list.
- *
- * See purple_account_remove_buddy().
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_blist_remove_buddy(PurpleBuddy *buddy);
-
-/**
  * purple_blist_remove_contact:
  * @contact: The contact to be removed
  *
@@ -370,52 +322,6 @@
 void purple_blist_remove_group(PurpleGroup *group);
 
 /**
- * purple_blist_find_buddy:
- * @account: The account this buddy belongs to
- * @name:    The buddy's name
- *
- * Finds the buddy struct given a name and an account
- *
- * Returns: (transfer none): The buddy or %NULL if the buddy does not exist.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-PurpleBuddy *purple_blist_find_buddy(PurpleAccount *account, const char *name);
-
-/**
- * purple_blist_find_buddy_in_group:
- * @account: The account this buddy belongs to
- * @name:    The buddy's name
- * @group:   The group to look in
- *
- * Finds the buddy struct given a name, an account, and a group
- *
- * Returns: (transfer none): The buddy or %NULL if the buddy does not exist in
- *          the group.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-PurpleBuddy *purple_blist_find_buddy_in_group(PurpleAccount *account, const char *name,
-		PurpleGroup *group);
-
-/**
- * purple_blist_find_buddies:
- * @account: The account this buddy belongs to
- * @name:    The buddy's name (or NULL to return all buddies for the account)
- *
- * Finds all PurpleBuddy structs given a name and an account
- *
- * Returns: (element-type PurpleBuddy) (transfer container): %NULL if the buddy
- *          doesn't exist, or a GSList of PurpleBuddy structs.
- *
- * Since: 3.0
- */
-PURPLE_AVAILABLE_IN_3_0
-GSList *purple_blist_find_buddies(PurpleAccount *account, const char *name);
-
-/**
  * purple_blist_find_group:
  * @name:    The group's name
  *
@@ -441,30 +347,6 @@
 PurpleGroup *purple_blist_get_default_group(void);
 
 /**
- * purple_blist_add_account:
- * @account:   The account
- *
- * Called when an account connects.  Tells the UI to update all the
- * buddies.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_blist_add_account(PurpleAccount *account);
-
-/**
- * purple_blist_remove_account:
- * @account:   The account
- *
- * Called when an account disconnects.  Sets the presence of all the buddies to 0
- * and tells the UI to update them.
- *
- * Since: 2.0
- */
-PURPLE_AVAILABLE_IN_ALL
-void purple_blist_remove_account(PurpleAccount *account);
-
-/**
  * purple_blist_walk:
  * @group_func: (scope call): The callback for groups
  * @meta_contact_func: (scope call): The callback for meta-contacts
